#include "sgl.h"
#include "flash.h"
#include "datel-ar.h"
/* #include "ar4mp.h" */
/* #include "arplus.h" */

Uint16 vendorid = 0;
Uint16 devid = 0;
Uint16 data = 0xFFFF;
Uint32 rom_size = 0;
Uint32 rom_pagesize = 0;
Uint32 rom_page = 0;
Uint16* arrom = (Uint16*)arrom_image;

void ss_main(void) {
	slInitSystem(TV_320x224, NULL, 1);
	slPrint("Action Replay Flasher", slLocate(4,2));
	slPrint("Revision 9", slLocate(4,3));
	slPrint("Checking Flash Vendor ID...", slLocate(4,5));
	slSynch();

	vendorid = flash_vendorid();
	slPrintHex((Uint32)vendorid, slLocate(22, 5));
	slSynch();

	slPrint("Checking Flash Device ID...", slLocate(4,6));
	devid = flash_devid();
	slPrintHex((Uint32)devid, slLocate(22,6));
	slSynch();

	/* The following is quite broken, as it has no support whatsoever
	for correlating vendor/device IDs. */

	switch(vendorid) {
	case 0xBFBF: slPrint("Vendor: Silicon Storage Technology",slLocate(4,7)); break;
	case 0x1F1F: slPrint("Vendor: Atmel", slLocate(4,7)); break;
	case 0xFFFF: slPrint("No Vendor ID - check cartridge connection.",slLocate(4,7)); break;
	default: slPrint("Unknown Vendor ID - proceed with caution!",slLocate(4,7)); break;
	}

	switch(devid) {
	case 0x0707: slPrint("Device: SST29EE010", slLocate(4,8)); break;
	case 0xD5D5: slPrint("Device: AT29C010", slLocate(4,8)); break;
	case 0xFFFF: slPrint("No Device ID - check cartridge connection.", slLocate(4,8)); break;
	default: slPrint("Unknown Device ID - proceed with caution!", slLocate(4,8)); break;
	}
	slSynch();


	/* This stuff should *really* be detected from the vendor/device ID... */
	rom_size = 131072; /* Size of the flash in words */
	rom_pagesize = 128; /* Size of a single flash page */

	slPrint("Press A+B+C+Start to initiate write...", slLocate(4,10));

	while(1) {
		if (!(Smpc_Peripheral[0].data & (PER_DGT_TA | PER_DGT_TB | PER_DGT_TC | PER_DGT_ST))) break;
		slSynch();
	}

	slPrint("Writing...", slLocate(4,12));

	for (rom_page = 0; rom_page < 262144 / 128 / 2; rom_page++) {
	  flash_erase((volatile Uint16 *)(ADDR_VENDOR + (rom_page * 128)));
	}

	for(rom_page = 0; rom_page < ARROM_LEN / 128 / 2 ; rom_page++) {
 	slPrint("Page          of          ", slLocate(4,13));
	slDispHex(rom_page, slLocate(9,13));
	slDispHex((ARROM_LEN / 128 / 2) - 1, slLocate(25,13));
	flash_erase((volatile Uint16 *)(ADDR_VENDOR + (rom_page * 128)));
	flash_write((volatile Uint16 *)(arrom + (rom_page * 128)), ADDR_VENDOR + rom_page * 128);
	}

	slPrint("Done!", slLocate(4,15));

	while(1) {
		slSynch();
	}
}
